          PROCESSOR 16f84

#include        "p16f84.inc"

        __CONFIG _CP_OFF & _WDT_OFF & _HS_OSC
          RADIX DEC
VideoMode       equ  20h
Loops           equ  21h
LineaCnt        equ  22h
SearchCnt       equ  23h
CntSyncOk       equ  24h
CntSyncErr      equ  25h
Slower          equ  26h
Faster          equ  27h
DataSample      equ  28h
PASSVIDEO       equ  00010011b
PASSINVER       equ  00110010b
PASSBLACK       equ  10010000b
MAKESYNC        equ  10000000b
MAKEBURST       equ  11010000b
NEG             equ  2
POS             equ  3
M_NEG           equ  00000100b
M_POS           equ  00001000b
DEC             equ  0
INV             equ  1
BLK             equ  2
ERR             equ  3
L318            equ  4
FIND            equ  5
OSCTRLON        equ  00001000b
OSCTRLOFF       equ  00001001b

        ORG     0
        goto    MAIN
HORLINEA                    
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        incf    Faster,f      
        incf    Slower,f        
        movlw   PASSBLACK
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB         
                                
        nop
        nop
        nop
        nop
        movlw   MAKESYNC
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB       
                             
        movlw   6            
        movwf   Loops
L1                              
        decfsz  Loops,f         
        goto    L1

        movlw   MAKEBURST
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB           
                               
        movf    PORTB,W         
        movwf   DataSample
        nop
        nop
        btfsc   DataSample,NEG  
        bsf     DataSample,POS  
        bcf     PORTA,0         
        btfsc   DataSample,POS  
        bsf     PORTA,0         
        movlw   OSCTRLON
        tris    PORTA          
        btfss   DataSample,POS 
        clrf    Faster         
        btfsc   DataSample,POS 
        clrf    Slower          
        btfsc   Faster,6        
        goto    L2           
        btfsc   Slower,6        
        goto    L2             
L2                             
        nop
        nop
        movlw   PASSVIDEO
        btfsc   VideoMode,INV   
        movlw   PASSINVER
        btfsc   VideoMode,BLK
        movlw   PASSBLACK
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB      
        movf    PORTB,W        
        iorwf   PORTB,W      
        iorwf   PORTB,W         
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        movwf   DataSample
        btfsc   VideoMode,FIND  
        goto    SEARCH          
        movlw   73          
        movwf   Loops
L3                          
        decfsz  Loops,f         
        goto    L3
        nop
        nop
        movlw   OSCTRLOFF
        tris    PORTA         
        decf    LineaCnt,f
        btfsc   STATUS,Z     
                                
        retlw   1            
        goto    L4            
L4      goto    L5
L5      goto    L6
L6      goto    HORLINEA      
SEARCH
        movlw   7
        movwf   SearchCnt
S1
        btfsc   PORTB,POS   
        goto    SEARCH   
        btfsc   PORTB,POS 
        goto    SEARCH     
        btfsc   PORTB,POS
        goto    SEARCH
        btfsc   PORTB,POS     
        goto    SEARCH        
        btfsc   PORTB,POS
        goto    SEARCH
        btfsc   PORTB,POS
        goto    SEARCH
        btfsc   PORTB,POS
        goto    SEARCH
        decfsz  SearchCnt,1   
        goto    S1
S2
        btfss   PORTB,POS      
        goto    S2
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        movf    PORTB,W
        iorwf   PORTB,W        
        iorwf   PORTB,W         
        movwf   DataSample
        btfsc   DataSample,NEG  
        goto    SEARCH          
        btfsc   DataSample,POS  
        goto    SEARCH         
        movf    PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W         
        iorwf   PORTB,W
        movwf   DataSample
        btfss   DataSample,NEG  
        goto    SEARCH         
        nop
        nop
        nop
        nop
        nop
        nop
        movf    PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W       
        iorwf   PORTB,W         
        movwf   DataSample
        btfss   DataSample,POS  
        goto    SEARCH         
        movlw   100             
        movwf   Loops
S3
        decfsz  Loops,1        
        goto    S3
        movf    PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W         
        iorwf   PORTB,W      
        movwf   DataSample
        btfss   DataSample,NEG 
        goto    SEARCH          
        movlw   157          
        movwf   Loops
S4
        decfsz  Loops,1     
        goto    S4
        nop
        movf    PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W        
        iorwf   PORTB,W        
        movwf   DataSample
        btfss   DataSample,NEG  
        goto    SEARCH       
        nop
        nop
        movlw   199           
        movwf   Loops
S5
        decfsz  Loops,1     
        goto    S5
        bcf     VideoMode,FIND  
        movlw   OSCTRLOFF
        tris    PORTA       
        retlw   1
MODE                        
        btfss   VideoMode,ERR 
        clrf    CntSyncErr    
        incf    CntSyncErr,f 
        btfsc   CntSyncErr,2   
        bcf     VideoMode,DEC   
        btfsc   CntSyncErr,2 
        bsf     VideoMode,FIND  
        btfsc   CntSyncErr,2   
        clrf    CntSyncErr     
        incf    CntSyncOk,f    
        btfsc   VideoMode,ERR   
        clrf    CntSyncOk       
        btfsc   CntSyncOk,2     
        bsf     VideoMode,DEC   
        bcf     VideoMode,ERR
        bsf     PORTA,1         
        btfsc   VideoMode,DEC   
        bcf     PORTA,1         
        movlw   44            
        movwf   Loops
LOOPM                          
        decfsz  Loops,f         
        goto    LOOPM
                        
        retlw   1
MEDLINEA                     
        movlw   5            
        movwf   Loops
ML1                          
        decfsz  Loops,f   
        goto    ML1
        nop
        movlw   MAKESYNC
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        btfss   VideoMode,L318
        movwf   PORTB           
                           
        movlw   5              
        movwf   Loops
ML2                      
        decfsz  Loops,f   
        goto    ML2
        nop
        nop
        movlw   MAKEBURST
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        btfss   VideoMode,L318
        movwf   PORTB        
                              
        movlw   8            
        movwf   Loops
ML3                          
        decfsz  Loops,f      
        goto    ML3
        movlw   PASSBLACK
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB         
        movlw   25           
        movwf   Loops
ML4                      
        decfsz  Loops,f      

        goto    ML4
        nop
                            
        retlw   1
VBI                        
        nop
        clrf    DataSample   
        movlw   05             
        movwf   Loops
V1
        decfsz  Loops,f
        goto    V1
PREEQ
        movlw   MAKESYNC
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB   
                            
        nop
        movlw   2            
        movwf   Loops
V2                          
        decfsz  Loops,f      
        goto    V2
        movlw   PASSBLACK
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB           
        nop
        movlw   46
        movwf   Loops
V3                            
        decfsz  Loops,f
        goto    V3
        movlw   5              
        decfsz  LineaCnt,f
        goto    PREEQ
        movwf LineaCnt
VSYNC
        movlw   MAKESYNC
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB           
        movlw   44        
        movwf   Loops
V4
        decfsz  Loops,f         
        goto    V4
        movlw   PASSBLACK
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB         
        movf    PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W
        iorwf   PORTB,W  
        movwf   DataSample
        btfss   DataSample,POS
        bsf     VideoMode,ERR 
        movlw   5            
        decfsz  LineaCnt,f
        goto    VSYNC
        movwf   LineaCnt
POSEQ
        movlw   MAKESYNC
        btfss   VideoMode, DEC
        movlw   PASSVIDEO
        movwf   PORTB        

        nop
        movlw   2
        movwf   Loops
V5                           
        decfsz  Loops,f       
        goto    V5
        movlw   PASSBLACK
        btfss   VideoMode,DEC
        movlw   PASSVIDEO
        movwf   PORTB          

        movlw   38
        movwf   Loops
V6                          
        decfsz  Loops,f        
        goto    V6
        decf    LineaCnt,f
        btfsc   STATUS,Z
        retlw   1             
        nop
        nop
        movlw   07
        movwf   Loops
V7
        decfsz  Loops,f
        goto    V7
        goto    POSEQ
MAIN    ; bsf     STATUS,RP0      
        movlw   00001001b
        tris    PORTA        
        movlw   M_POS+M_NEG
        tris    PORTB          
        ; bcf     STATUS,RP0     
        movlw   PASSVIDEO      
        movwf   PORTB          
        bsf     PORTA,1
        clrf    VideoMode    
        movlw 1
        goto    START
LOOP1
        nop
        movlw   5            
        movwf   LineaCnt
        call    VBI         

        nop
        nop
        nop
        nop
        bsf     VideoMode,L318  
        call    MEDLINEA      

        nop
        nop
        bcf     VideoMode,L318  
        movlw   17
        movwf   LineaCnt
        call    HORLINEA        

        nop
        nop
        bcf     VideoMode,BLK 
        movlw   200
        movwf   LineaCnt
        call    HORLINEA       

        nop
        nop
        nop
        movlw   82
        movwf   LineaCnt
        call    HORLINEA      

        nop
        nop
        bsf     VideoMode,BLK  
        movlw   5
        movwf   LineaCnt
        call    HORLINEA        

        nop
        nop
        nop
        btfsc   DataSample,NEG  
        bcf     VideoMode,INV  
        call    MEDLINEA      

        nop
        nop
        nop
        movlw   5
        movwf   LineaCnt
        call    VBI          

        nop
        nop
        nop
        nop
        nop
        call    MEDLINEA        

        nop
        nop
        nop
        nop
        nop
        call    MODE        

START   nop
        nop
        nop
        nop
        movwf   LineaCnt
        call    HORLINEA        

        nop
        nop
        nop
        movlw   16
        movwf   LineaCnt
        call    HORLINEA      

        bcf     VideoMode,BLK   
        btfsc   DataSample,POS  
        bsf     VideoMode,INV   
        movlw   200
        movwf   LineaCnt
        call    HORLINEA      

        nop
        nop
        nop
        movlw   82
        movwf   LineaCnt
        call    HORLINEA      
        nop
        nop
        bsf     VideoMode,BLK  
        movlw   5
        movwf   LineaCnt
        call    HORLINEA       

        goto    LOOP1       

        END

